document.addEventListener("DOMContentLoaded", function () {
    var generateButton = document.getElementById("chatgpt-generate");
    if(generateButton) {
        generateButton.addEventListener("click", generateArticle);
    }

    // Fonction pour afficher le loader
    function showLoader() {
        const spinner = document.getElementById('spinner-overlay');
        spinner.style.display = 'flex';
    }

    // Fonction pour masquer le loader
    function hideLoader() {
        const spinner = document.getElementById('spinner-overlay');
        spinner.style.display = 'none';
    }

    function generateArticle() {
        showLoader();

        var key = data_chatbot.apikey;
        var languageField = document.getElementById("chatgpt-language");
        var stylesField = document.getElementById("chatgpt-styles");
        var tonesField = document.getElementById("chatgpt-tones");
        var titleField = document.getElementById("chatgpt-title");
        var tagsField = document.getElementById("chatgpt-tags");
        //var nbWordsField = document.getElementById("chatgpt-nb-words");
        var nbParagrahField = document.getElementById("chatgpt-nb-paragraph");
        //var nbSectionsField = document.getElementById("chatgpt-nb-sections");
        //var TitlesField = document.getElementById("chatgpt-titles");
        //var introConclusionField = document.getElementById("chatgpt-introconclusion");
        //var descriptionField = document.getElementById("chatgpt-description");

        var title = titleField.value;
        if (title === "") {
            alert("Veuillez saisir un sujet ou un titre.");
            hideLoader();
            return;
        }

        var keywords = tagsField.value;
        var paragraphCount = nbParagrahField.value;
        //var sectionsCount = nbSectionsField.value;
        var language = languageField.value;
        var style = stylesField.value;
        var ton = tonesField.value;
        //var titles = TitlesField.value;
        //var introConclusion = introConclusionField.value;

        // ${title}
        // ${language}
        // ${style}
        // ${ton}
        // ${keywords}
        // ${paragraphCount}
        // ${sectionsCount}
        // ${titles} // ${introConclusion}

        var prompt = `Je souhaite rédiger un article en ${language} sur ${title}, j'ai besoin que tu me rédiges le plan de l'article détaillé. Je veux que l'article soit composé de ${paragraphCount} titres avec des balises Hn selon leur importance. Chaque titre doit contenir entre 40 et 80 caractères.`;

        axios.post("https://api.openai.com/v1/completions", {
            model: "text-davinci-003",
            prompt: prompt,
            max_tokens: 3500,
        }, {
            headers: {
                "Content-Type": "application/json",
                "Authorization": `Bearer ${key}`
            }
        }).then(function (response) {
            var generatedText = response.data.choices[0].text.trim();

            var nprompt = `Write an article in ${language} about "${title}" emphasizing the following keywords : ${keywords}. The article is organized by the following headings:
            
            ${generatedText}
            
            Use Markdown for formatting.
            Style: ${style}. Tone: ${ton}.`;

            axios.post("https://api.openai.com/v1/completions", {
                model: "text-davinci-003",
                prompt: nprompt,
                max_tokens: 3500,
            }, {
                headers: {
                    "Content-Type": "application/json",
                    "Authorization": `Bearer ${key}`
                }
            }).then(function (response2) {
                var ngeneratedText = response2.data.choices[0].text.trim();

                //descriptionField.value = ngeneratedText;

                var converter = new showdown.Converter();

                // Convertit le texte Markdown en HTML
                var html = converter.makeHtml(ngeneratedText);

                // Crée un élément div pour le contenu HTML
                var $content = jQuery('<div>').html(html);

                // Récupère les balises de titre et de paragraphe
                var $blocks = $content.find('h1, h2, h3, h4, h5, h6, p');

                // Crée les blocs Gutenberg correspondants dans l'ordre du texte initial
                $blocks.each(function () {
                    var blockText = jQuery(this).text();

                    // Vérifie le type de balise (titre ou paragraphe)
                    var isHeading = this.nodeName.startsWith('H');

                    if (isHeading) {
                        // Crée un bloc de titre avec le texte
                        var block = wp.blocks.createBlock('core/heading', { level: parseInt(this.nodeName.substring(1)), content: blockText });
                    } else {
                        // Crée un bloc de paragraphe avec le texte
                        var block = wp.blocks.createBlock('core/paragraph', { content: blockText });
                    }

                    // Ajoute le bloc à l'éditeur Gutenberg
                    wp.data.dispatch('core/block-editor').insertBlock(block);
                });

                // Masquer le loader
                hideLoader();

                /* if ( introConclusion ) {
                     axios.post("https://api.openai.com/v1/completions", {
                         model: "text-davinci-003",
                         prompt: `Write an introduction and a conclusion about "${title}". The article is organized by the following headings:

                         ${generatedText}

                         Use Markdown for formatting.
                         Style: ${style}. Tone: ${ton}.`,
                         max_tokens: 3500,
                     }, {
                         headers: {
                             "Content-Type": "application/json",
                             "Authorization": `Bearer ${key}`
                         }
                     }).then(function(response) {
                         var introConclu = response.data.choices[0].text.trim();
                         //descriptionField.value = introConclu;

                         // Masquer le loader
                         hideLoader();
                     });
                 }*/
            });
        }).catch(function (error) {
            console.error(error);
        });
    }
});