(function( $ ) {
    'use strict';

    $(document).ready(function () {
        $(document).find('.ays-assistant-chatbox').show();

        $(document).on('click', '.ays-assistant-chatbox-closed-view' ,function () {
            $(this).hide();
            var container = $(document).find('.ays-assistant-chatbox-main-container');
            var bg = $(document).find('.ays-assistant-chatbox-maximized-bg');
            if (container.hasClass('ays-assistant-chatbox-main-container-maximized-view')) {
                bg.show();
                $('body').addClass('ays-assistant-chatbox-disabled-scroll-body');
            }
            container.show();
            $(document).find('.ays-assistant-chatbox-prompt-input').focus();
        });

        $(document).on('click', '.ays-assistant-chatbox-close-bttn' ,function () {
            var container = $(this).parents('.ays-assistant-chatbox-main-container');
            var bg = $(document).find('.ays-assistant-chatbox-maximized-bg');
            if (container.hasClass('ays-assistant-chatbox-main-container-maximized-view')) {
                bg.hide();
                $('body').removeClass('ays-assistant-chatbox-disabled-scroll-body');
            }
            container.hide();
            $(document).find('.ays-assistant-chatbox-closed-view').show();
        });

        $(document).find('.ays-assistant-chatbox-resize-bttn').on('click', function () {
            var container = $(this).parents('.ays-assistant-chatbox-main-container');
            var bg = $(document).find('.ays-assistant-chatbox-maximized-bg');
            var src = $(this).attr('src');
            if (!container.hasClass('ays-assistant-chatbox-main-container-maximized-view')) {
                $(this).attr('src', src.replace('maximize', 'minimize'));
                $(this).attr('alt', "Minimize");
                container.addClass('ays-assistant-chatbox-main-container-maximized-view');
                bg.show();
                $('body').addClass('ays-assistant-chatbox-disabled-scroll-body');
            } else {
                $(this).attr('src', src.replace('minimize', 'maximize'));
                $(this).attr('alt', "Maximize");
                container.removeClass('ays-assistant-chatbox-main-container-maximized-view');
                bg.hide();
                $('body').removeClass('ays-assistant-chatbox-disabled-scroll-body');
            }
        });

        $(document).on('mouseup', function(e) {
            var container = $(document).find('.ays-assistant-chatbox-main-container');
            if (container.hasClass('ays-assistant-chatbox-main-container-maximized-view') && container.css('display') !== 'none') {
                if (!container.is(e.target) && container.has(e.target).length === 0) {
                    $(document).find('.ays-assistant-chatbox-resize-bttn').trigger("click");
                }
            }
        });

        $(document).find('.ays-assistant-chatbox-prompt-input').on('input', function () {
            var _this = this;

            var sendBttn = $(document).find('.ays-assistant-chatbox-send-button');

            if ($(_this).val().trim() != "") {
                sendBttn.prop('disabled', false);
            } else {
                sendBttn.prop('disabled', true);
            }
        });

        $(document).on('keypress', function (e) {
            if (e.which == 13) {
                var prompt = $(document).find('.ays-assistant-chatbox-prompt-input');
                if ($(prompt).val().trim() != '' &&  $(prompt).is(":focus")) {
                    var button = $(document).find('.ays-assistant-chatbox-send-button');
                    if ( !button.prop('disabled') ) {
                        button.trigger("click");
                    }
                }
            }
        });

        $(document).find('.ays-assistant-chatbox-send-button').on('click', function () {
            var url = "https://api.openai.com/v1/completions";
            var key = data_chatbot.apikey;
            var promptInput = $(document).find('.ays-assistant-chatbox-prompt-input');
            var prompt = promptInput.val();

            var loader = $(document).find('.ays-assistant-chatbox-loading-box');
            var sendBttn = $(document).find('.ays-assistant-chatbox-send-button');

            var userMessage = $("<div>", {"class": "ays-assistant-chatbox-user-message-box"}).html(prompt);
            $(document).find('.ays-assistant-chatbox-prompt-input').val('');

            $(document).find('.ays-assistant-chatbox-messages-box').append(userMessage).scrollTop($('.ays-assistant-chatbox-messages-box')[0].scrollHeight);
            var scrolledHeight = $('.ays-assistant-chatbox-messages-box')[0].scrollHeight;
            var elementHeight = Math.round($('.ays-assistant-chatbox-messages-box').outerHeight());
            loader.css('bottom', (10 + elementHeight - scrolledHeight));

            if (key != '' && prompt.trim() != '') {
                loader.show();
                sendBttn.prop('disabled', true);

                makeRequest(url, key, prompt)
                    .then(data => {
                        var checkError = (typeof data.error == "object" ) ? false : true;
                        if(checkError){
                            loader.hide();
                            $.ajax({
                                type: 'post',
                                url: data_chatbot.url,
                                data: {
                                    action: 'wps_chatbot_ai_ajax_save_chat',
                                    answer: prompt,
                                    response: (data.choices[0].text.replace(/^\n+/, '')),
                                    ip: AysChatGPTChatSettings.ip_client,
                                    nonce: data_chatbot.nonce,
                                }
                            });

                            var response = "<span>" + (data.choices[0].text.replace(/^\n+/, '')) + "</span>";
                            var buttons = '<div class="ays-assistant-chatbox-ai-message-buttons">';
                            buttons += '<div class="ays-assistant-chatbox-ai-message-copy" title="Click to Copy"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" fill="#636a84"><path d="M64 464H288c8.8 0 16-7.2 16-16V384h48v64c0 35.3-28.7 64-64 64H64c-35.3 0-64-28.7-64-64V224c0-35.3 28.7-64 64-64h64v48H64c-8.8 0-16 7.2-16 16V448c0 8.8 7.2 16 16 16zM224 304H448c8.8 0 16-7.2 16-16V64c0-8.8-7.2-16-16-16H224c-8.8 0-16 7.2-16 16V288c0 8.8 7.2 16 16 16zm-64-16V64c0-35.3 28.7-64 64-64H448c35.3 0 64 28.7 64 64V288c0 35.3-28.7 64-64 64H224c-35.3 0-64-28.7-64-64z"/></svg></div>';
                            buttons += '<div class="ays-assistant-chatbox-ai-message-tts"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 18 18" width="18px" fill="#636a84"><g id="surface3"><path style=" stroke:none;fill-rule:nonzero;fill-opacity:1;" d="M 2.25 6.75 L 2.25 11.25 L 5.25 11.25 L 9 15 L 9 3 L 5.25 6.75 Z M 12.375 9 C 12.375 7.675781 11.609375 6.53125 10.5 5.980469 L 10.5 12.023438 C 11.609375 11.46875 12.375 10.324219 12.375 9 Z M 10.5 2.421875 L 10.5 3.972656 C 12.667969 4.617188 14.25 6.621094 14.25 9 C 14.25 11.378906 12.667969 13.382812 10.5 14.027344 L 10.5 15.578125 C 13.503906 14.894531 15.75 12.214844 15.75 9 C 15.75 5.785156 13.503906 3.105469 10.5 2.421875 Z M 10.5 2.421875 "/></g></svg></div>';
                            buttons += '</div>';
                            var aiMessage = $("<div>", {"class": "ays-assistant-chatbox-ai-message-box"}).html(response + buttons);

                            $(document).find('.ays-assistant-chatbox-messages-box').append(aiMessage).scrollTop($('.ays-assistant-chatbox-messages-box')[0].scrollHeight);
                            var scrolledHeight = $('.ays-assistant-chatbox-messages-box')[0].scrollHeight;
                            var elementHeight = Math.round($('.ays-assistant-chatbox-messages-box').outerHeight());
                            loader.css('bottom', (10 + elementHeight - scrolledHeight));
                            $('.ays-assistant-chatbox-ai-message-tts').on('click', function () {
                                var text = $(this).parents('.ays-assistant-chatbox-ai-message-buttons').prev('span').text();
                                ttsResponse(text);
                            });

                            $('.ays-assistant-chatbox-ai-message-copy').on('mouseover', function () {
                                $(this).attr('title', 'Click to Copy');
                            });
                        }
                        else{
                            loader.hide();
                            var errorMessage = '';
                            if(data.error.type == "insufficient_quota"){
                                errorMessage = " <a href='https://platform.openai.com/account/usage'> https://platform.openai.com/account/usage </a>";
                            }
                            $(document).find('.ays-assistant-chatbox-messages-box').append($("<div>", {"class": "ays-assistant-chatbox-error-message-box"}).html(data.error.message + errorMessage));
                        }
                    })
            }
        });

        function makeRequest (url, key, prompt, tries = 0) {
            var chatTemperature = AysChatGPTChatSettings.chatTemprature ? +AysChatGPTChatSettings.chatTemprature : 0.7;
            var chatMaxTokents  = AysChatGPTChatSettings.chatMaxTokents ? +AysChatGPTChatSettings.chatMaxTokents : 1500;

            var chatFrequencyPenalty = AysChatGPTChatSettings.chatFrequencyPenalty ? +AysChatGPTChatSettings.chatFrequencyPenalty : 0.01;
            var chatPresencePenalty = AysChatGPTChatSettings.chatPresencePenalty ? +AysChatGPTChatSettings.chatPresencePenalty : 0.01;

            var chatBestOf      = AysChatGPTChatSettings.chatBestOf     ? +AysChatGPTChatSettings.chatBestOf : 1;

            console.log("Converse as if you were an AI assistant whose function is " + AysChatGPTChatSettings.chatboxFunctionJob + ". Answer the question in a " + AysChatGPTChatSettings.chatboxPersonality + " way in the language " + AysChatGPTChatSettings.chatboxLanguage + " with the gender " + AysChatGPTChatSettings.chatboxGender + "." + prompt + ".");

            return fetch(url, {
                method: "POST",
                headers: {
                    "Content-Type": "application/json",
                    "Authorization": `Bearer ${key}`
                },
                body: JSON.stringify({
                    model: "text-davinci-003",
                    prompt: "Converse as if you were an AI assistant whose function is '" + AysChatGPTChatSettings.chatboxFunctionJob + "'. Answer the question in a " + AysChatGPTChatSettings.chatboxPersonality + " way in the language " + AysChatGPTChatSettings.chatboxLanguage + " with the gender " + AysChatGPTChatSettings.chatboxGender + "." + prompt + ".",
                    temperature: chatTemperature,
                    max_tokens: chatMaxTokents,
                    frequency_penalty: chatFrequencyPenalty,
                    presence_penalty:  chatPresencePenalty,
                    // top_p:  0.5,
                    best_of: chatBestOf,
                })
            })
                .then(response => {
                    return response.json();
                })

        }

        function copyResponse (text) {
            var el = jQuery('<textarea>').appendTo('body').val(text).select();
            document.execCommand('copy');
            el.remove();
        }

        function ttsResponse(text) {
            if (!('speechSynthesis' in window)) {
                alert('Text-to-speech not supported in this browser');
                return;
            }

            var synth = window.speechSynthesis;
            synth.cancel();
            var utterance = new SpeechSynthesisUtterance(text);
            utterance.lang = 'en';

            // synth.addEventListener('voiceschanged', function() {
            // 	var voices = synth.getVoices();
            // 	if (voices.length === 0) {
            // 	  	alert('No voices available for text-to-speech');
            // 	  	return;
            // 	}
            // 	utterance.voice = voices[2];
            // 	synth.speak(utterance);
            // });

            synth.speak(utterance);
        }

        window.addEventListener('unload', function(event) {
            event.preventDefault();
            speechSynthesis.cancel();
        });

        window.addEventListener("blur", (event) => {
            event.preventDefault();
            var synth = window.speechSynthesis;
            synth.cancel();
        });

        $(document).on('click', '.ays-assistant-chatbox-ai-message-copy', function(){
            var _this = $(this);
            var text = _this.parents('.ays-assistant-chatbox-ai-message-buttons').prev('span').text();
            copyResponse(text);
            _this.attr('title', 'Copied!');

            var copyIcon = _this.html();
            _this.html('<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" fill="#636a84"><path d="M470.6 105.4c12.5 12.5 12.5 32.8 0 45.3l-256 256c-12.5 12.5-32.8 12.5-45.3 0l-128-128c-12.5-12.5-12.5-32.8 0-45.3s32.8-12.5 45.3 0L192 338.7 425.4 105.4c12.5-12.5 32.8-12.5 45.3 0z"/></svg>');
            setTimeout(function() {
                _this.html(copyIcon);
            }, 700);
        });

        function makeResizableDiv (el) {
            var element = document.querySelector(el);
            var resizer = document.querySelector(el + ' .ays-assistant-chatbox-header-row')
            var minimum_width = 320;
            var minimum_height = 430;
            var original_width = 0;
            var original_height = 0;
            var original_x = 0;
            var original_y = 0;
            var original_mouse_x = 0;
            var original_mouse_y = 0;
            if (resizer) {
                resizer.addEventListener('mousedown', function(e) {
                    e.preventDefault();
                    original_width = parseFloat(getComputedStyle(element, null).getPropertyValue('width').replace('px', ''));
                    original_height = parseFloat(getComputedStyle(element, null).getPropertyValue('height').replace('px', ''));
                    original_x = element.getBoundingClientRect().left;
                    original_y = element.getBoundingClientRect().top;
                    original_mouse_x = e.pageX;
                    original_mouse_y = e.pageY;
                    window.addEventListener('mousemove', resize);
                    window.addEventListener('mouseup', stopResize);
                });
            }

            function resize (e) {
                if (!$(document).find('.ays-assistant-chatbox-main-container').hasClass('ays-assistant-chatbox-main-container-maximized-view')) {
                    if (AysChatGPTChatSettings.chatboxPosition !== 'right') {
                        var width = original_width + (e.pageX - original_mouse_x)
                        var height = original_height - (e.pageY - original_mouse_y)
                        var maximum_width = window.innerWidth - 50;
                        var maximum_height = window.innerHeight - 50;
                        if (width < maximum_width && height < maximum_height) {
                            if (width > minimum_width) {
                                element.style.width = width + 'px';
                            }
                            if (height > minimum_height) {
                                element.style.height = height + 'px';
                            }
                        }
                    } else {
                        var width = original_width - (e.pageX - original_mouse_x);
                        var height = original_height - (e.pageY - original_mouse_y);
                        var maximum_width = window.innerWidth - 50;
                        var maximum_height = window.innerHeight - 50;
                        if (width < maximum_width && height < maximum_height) {
                            if (width > minimum_width) {
                                element.style.width = width + 'px';
                            }
                            if (height > minimum_height) {
                                element.style.height = height + 'px';
                            }
                        }
                    }
                }
            }

            function stopResize () {
                window.removeEventListener('mousemove', resize);
            }
        }
        makeResizableDiv(".ays-assistant-chatbox-main-container");

    });


})( jQuery )
