<?php
// don't load directly
if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}

$plugin              = 'migrate-guru/migrateguru.php';

$is_plugin_installed = \WPS\WPS_Chatbot_AI\Pub::is_plugin_installed( $plugin );

if ( ! $is_plugin_installed ) {
	$classes    = 'install-now';
	$action_url = wp_nonce_url( add_query_arg(
		array(
			'action' => 'install-plugin',
			'plugin' => 'migrate-guru',
		),
		network_admin_url( 'update.php' )
	), 'install-plugin_migrate-guru' );
	$button     = __( 'Install Migrate Guru', 'wps-ai-chatgpt' );
} else {
	$action_url = wp_nonce_url( add_query_arg(
		array(
			'action'        => 'activate',
			'plugin'        => $plugin,
			'plugin_status' => 'all',
			'paged'         => 1
		),
		network_admin_url( 'plugins.php' )
	), 'activate-plugin_' . $plugin );

	$button = __( 'Enable Migrate Guru', 'wps-ai-chatgpt' );
}

if ( empty( $action_url ) ) {
	return false;
}

$details_url = add_query_arg(
	array(
		'tab'       => 'plugin-information',
		'plugin'    => 'migrate-guru',
		'TB_iframe' => true,
		'width'     => 722,
		'height'    => 949,
	),
	network_admin_url( 'plugin-install.php' )
); ?>
<div class="pub-wp-serveur plugin-card plugin-card-migrate-guru">
	<div class="logo">
		<a href="https://www.wpserveur.net/?refwps=14&campaign=wpsaichatgps" target="_blank">
			<img src="https://www.wpserveur.net/muwps/WPServeur-logo-white.svg" alt="WPServeur" height="auto"
			     width="200"/>
		</a>
	</div>
	<div class="message">
		<strong><?php _e( 'Discover the specialized WordPress hosting with WPServeur!', 'wps-ai-chatgpt' ); ?></strong>
		<strong><?php _e( 'For fast, secure and efficient hosting.', 'wps-ai-chatgpt' ); ?></strong><br/>
		<?php _e( 'We only do WordPress but we do it well!', 'wps-ai-chatgpt' ); ?><br/>
		<i style="font-size:11px;"><?php _e( '(-10% discount on your subscription with the promo code <strong>WPSC&T</strong>)', 'wps-ai-chatgpt' ); ?></i>
	</div>
	<div class="cta">
		<a href="https://www.wpserveur.net/?refwps=14&campaign=wpsaichatgps" target="_blank"
		   class="btn-pubwps btn-abonner"><?php _e( 'Subscribe to WPServeur', 'wps-ai-chatgpt' ); ?></a>
		<a data-slug="migrate-guru" href="<?php echo $action_url; ?>"
		   class="btn-pubwps btn-install-plugin <?php echo $classes; ?>"><?php echo $button; ?></a>
		<a href="<?php echo $details_url; ?>"
		   class="thickbox open-plugin-details-modal btn-wps-details"><?php echo sprintf( __( 'More about %s', 'wps-ai-chatgpt' ), 'Migrate Guru' ); ?></a>
	</div>
</div>

<style>
    /*pub WPServeur*/
    .wps-autopromo .pub-wp-serveur {
        background: #33414E !important;
        float: none;
        width: 100%;
        padding: 10px;
        border: 0 none;
        box-shadow: none;
        color: #FFF !important;
        margin: 0 0 45px 0 !important;
        box-sizing: border-box;
        border-radius: 5px;
    }

    .wps-autopromo .pub-wp-serveur:first-child {
        margin-top: 40px !important;
    }

    .wps-autopromo .pub-wp-serveur.plugin-card-migrate-guru {
        margin-top: 0px !important;
    }

    .wps-autopromo .pub-wp-serveur:last-child {
        margin-bottom: 0px !important;
    }

    .wps-autopromo .pub-wp-serveur .logo {
        padding: 0px 20px;
        text-align: center;
        margin-bottom: 5px;
    }

    .wps-autopromo .pub-wp-serveur > .wps-pub-logo {
        margin-top: -45px;
        text-align: center;
        position: relative;
    }

    .wps-autopromo .pub-wp-serveur > .wps-pub-logo img {
        border-radius: 100%;
    }

    .wps-autopromo .pub-wp-serveur > .wps-pub-logo:before {
        content: '';
        display: block;
        width: 64px;
        height: 64px;
        border: 3px solid rgba(255, 255, 255, 0.27);
        box-shadow: 0px 0px 0px 5px #f2f2f2;
        position: absolute;
        border-radius: 100%;
        margin: 0 auto;
        left: 0;
        right: 0;
        top: 0;
        box-sizing: border-box;
    }

    .admin-color-light .wps-autopromo .pub-wp-serveur > .wps-pub-logo:before {
        box-shadow: 0px 0px 0px 5px #f5f5f5;
    }

    .wps-autopromo .pub-wp-serveur > .message {
        width: 100%;
        padding: 0px;
        font-size: 14px;
        box-sizing: border-box;
        margin-bottom: 15px;
        text-align: center;
    }

    .wps-autopromo .pub-wp-serveur .cta {
        padding: 0px 0px;
        display: flex;
    }

    .wps-autopromo .btn-install-plugin.activate-now,
    .wps-autopromo .btn-pubwps {
        display: block;
        background: #fff;
        width: 100%;
        padding: 8px 20px;
        white-space: nowrap;
        margin-bottom: 4px;
        text-decoration: none;
        text-align: center;
        font-weight: 500;
        border-radius: 4px;
        line-height: 18px;
        height: unset;
        text-shadow: none;
        box-sizing: border-box;
        margin-right: 40px;
    }

    .wps-autopromo .plugin-card-wps-bidouille .notice-dismiss:before {
        color: #ffffff;
        font: 400 26px/26px dashicons;
    }

    .wps-autopromo .btn-wps-details {
        color: #fff;
    }

    .wps-autopromo .btn-abonner {
        background: #95bf23;
        color: #fff;
    }

    .wps-autopromo .btn-abonner:focus,
    .wps-autopromo .btn-abonner:hover {
        color: #95bf23;
        background: #fff;
        box-shadow: none !important;
    }

    .wps-autopromo .btn-install-plugin.activate-now,
    .wps-autopromo .btn-install-plugin {
        background: #26a0d2;
        color: #fff;
        position: relative;
    }

    .wps-autopromo .btn-install-plugin.activate-now:hover,
    .wps-autopromo .btn-install-plugin:hover {
        color: #26a0d2;
        background: #fff;
    }

    .wps-autopromo .btn-wps-details {
        text-align: center;
        width: 100%;
        display: block;
        white-space: nowrap;
        padding: 0 20px;
        box-sizing: border-box;
        margin: auto;
    }

    .wps-autopromo a.btn-wps-details:focus {
        color: #fff !important;
        box-shadow: none !important;
    }

    .wps-autopromo .btn-install-plugin.updating-message:before {
        font: normal 20px/1 'dashicons';
        position: absolute;
        left: 10px;
        top: 7px;
    }

    @media screen and (max-width: 860px) {
        .wps-autopromo .pub-wp-serveur,
        .wps-autopromo .pub-wp-serveur .logo,
        .wps-autopromo .pub-wp-serveur .message,
        .wps-autopromo .pub-wp-serveur .cta {
            display: block !important;
            padding: 5px 10px;
        }

        .wps-autopromo .btn-pubwps {
            width: unset;
        }

        .wps-autopromo .pub-wp-serveur .message,
        .wps-autopromo .pub-wp-serveur .logo {
            text-align: center;
        }

        .wps-autopromo .pub-wp-serveur .cta {
            margin-bottom: 20px;
        }
    }

    /*pub hébergement*/
    @media screen and (min-width: 1150px) {
        .wps-tab {
            float: left;
            width: calc(100% - 320px);
            width: -moz-calc(100% - 320px);
            width: -webkit-calc(100% - 320px);
            box-sizing: border-box;
        }
    }
</style>